\ Additional definitions for VFXTESTAPPbitV3.f  needed for  Mecrisp on the Micro Bit     Juergen Pintaske - ExMark - 2016-09_26
\ These Words are magic and more difficult, to be explained later. 
\ They add the functionality MS and PAGE to Mecrisp as needed by the VFXTESTAPP
\ as well the timing loops have to be adjusted - counter, scounter, sos     
: MS 0 DO  2500 0 DO LOOP LOOP ;   \   wait for about 1 millisecond  ( Loop number L1=410, L0=11 ),  
         \ adjust 2500 to get one msec delay in software according to the clock frequency used.
\
: u.base10 ( u -- ) base @ decimal swap 0 <# #s #> type base ! ;
: ESC[         ( -- ) 27 emit 91 emit ;
: at-xy ( column row -- ) 1+ swap 1+ swap ESC[ u.base10 ." ;" u.base10 ." H" ;
: page ESC[ ." 2J" 0 0 at-xy ;
\
 \ :  putpixel ( x y -- )  at-xy [char] * emit ;    \ not needed for now but probably later 
\ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
\ App from here onwards
\ MPE_VFX_TESTAPP  Write a simple Application - just 35 Forth Words, 
\ set IO bits, start a counter, send SOS, - ExMark, Juergen Pintaske 2016_09_22 
HEX \ from now on all of the numbers are hexadecimal.  MMT lines print a display window GUI, very basic, just uses Page and CR
: Line1 ." \ copy text in VFXTESTAPPbitV3.f into TerTerm, hit <cr> ExMark Juergen Pintaske 22Sept2016" CR ; \ 
: Line2 ." \ PWHL T3HL T2HL T1HL O3HL O2HL O1HL O0HL I3HL I2HL I1HL I0HL A3HL A2HL A1HL A0HL h/l ????" CR ; \ ???? DEBUG 
: Line3 ." \ PWM  T3___T2___T1   O3___O2___O1___O0   I3___I2___I1___I0   A3___A2___A1___A0  " CR ;
Variable PSWI   ( Combined PWM and Switches   X s s s  )  
Variable OUTP   ( OUTP 3 2 1 0 )( same as Bit 7 6 5 4  )  
Variable IN     ( IN   3 2 1 0  ( 3 2 1 0 of the 8 Bits )  
Variable ANI    ( Simulated analog input 0 to F, or just a Variable )  
: disbit4  DUP $8 AND IF ." 1" ELSE ." 0" THEN  ;   
: ds       Disbit4 1 LSHIFT ;                       \ 
: dssp     ds Space Space space space ;             \ 
: 4dssp    dssp dssp dssp disbit4  drop ;           \ 
: DATA     3 spaces PSWI @ 4dssp  4 spaces OUTP @ 4dssp 4 spaces IN @ 4dssp  4 spaces  ANI @ 4dssp  ;  \ display the 16 bits
: SPACES   ( u -- ) 0 ?DO SPACE LOOP ;              \ define SPACES, often included in the wordset already
: MBV2     PAGE   Line1   Line2    Line3   DATA  CR ;  \ MultipleBitValues2 updates the SCREEN
: COUNTER  Begin outp @ 1+ outp !     300 ms mbv2 key? until ; \ run counter program, see the OUT bits change, just type counter <cr>
: SCOUNTER Begin dup outp @ 1+ outp !     ms mbv2 key? until ; \  programmable speed, for example 400 scounter cr
: SOS 07 emit 100 ms 07 emit 100 ms 07 emit 600 ms 07 emit 300 ms 07 emit 300 ms 07 emit 600 ms 07 emit 100 ms 07 emit 100 ms 07 emit ;
: ????   3 spaces PSWI @ . OUTP @ . IN @ . ANI @ . 4 spaces >R >R >R >R >R >R >R >R R> DUP . R> DUP . R> DUP . R> DUP . R> DUP . R> DUP . R> DUP . R> DUP . ;
\ Preset Variables:
9 PSWI !    0 OUTP !    3 IN   !    F ANI  !    \ 
\ Control Words ( from left to right as shown in MMT3 )
: PWH   PSWI @  $8 OR   PSWI !  MBV2 ; \ 
: T3H   PSWI @  $4 OR   PSWI !  MBV2 ; \ 
: T2H   PSWI @  $2 OR   PSWI !  MBV2 ; \ A
: T1H   PSWI @  $1 OR   PSWI !  MBV2 ;
: O3H   OUTP @  $8 OR   OUTP !  MBV2 ;  \ x x x x    1 0 0 0    OR    e.g. 0101   gives 1101
: O2H   OUTP @  $4 OR   OUTP !  MBV2 ;  \            0 1 0 0    OR    e.g. 0001   gives 0101
: O1H   OUTP @  $2 OR   OUTP !  MBV2 ;  \            0 0 1 0    OR    e.g. 0101   gives 0110
: O0H   OUTP @  $1 OR   OUTP !  MBV2 ;  \            0 0 0 1    OR    e.g. 0100   gives 0101
: I3H   IN   @  $8 OR   IN   !  MBV2 ;
: I2H   IN   @  $4 OR   IN   !  MBV2 ;
: I1H   IN   @  $2 OR   IN   !  MBV2 ;
: I0H   IN   @  $1 OR   IN   !  MBV2 ;
: A3H   ANI  @  $8 OR   ANI  !  MBV2 ;
: A2H   ANI  @  $4 OR   ANI  !  MBV2 ;
: A1H   ANI  @  $2 OR   ANI  !  MBV2 ;
: A0H   ANI  @  $1 OR   ANI  !  MBV2 ;  \ here end the words that Set Bits HIGH - the next ones set the same bits LOW
: PWL   PSWI @  $7 AND  PSWI !  MBV2 ;  \ x x x x    0 1 1 1    AND    e.g. 1111   gives 0111
: T3L   PSWI @  $B AND  PSWI !  MBV2 ;  \            1 0 1 1    AND    e.g. 1111   gives 1011
: T2L   PSWI @  $D AND  PSWI !  MBV2 ;  \            1 1 0 1    AND    e.g. 1111   gives 1101
: T1L   PSWI @  $E AND  PSWI !  MBV2 ;  \            1 1 1 0    AND    e.g. 1111   gives11110
: O3L   OUTP @  $7 AND  OUTP !  MBV2 ;
: O2L   OUTP @  $B AND  OUTP !  MBV2 ;
: O1L   OUTP @  $D AND  OUTP !  MBV2 ;
: O0L   OUTP @  $E AND  OUTP !  MBV2 ;
: I3L   IN   @  $7 AND  IN   !  MBV2 ;
: I2L   IN   @  $B AND  IN   !  MBV2 ;
: I1L   IN   @  $D AND  IN   !  MBV2 ;
: I0L   IN   @  $E AND  IN   !  MBV2 ;
: A3L   ANI  @  $7 AND  ANI  !  MBV2 ;
: A2L   ANI  @  $B AND  ANI  !  MBV2 ;
: A1L   ANI  @  $D AND  ANI  !  MBV2 ;
: A0L   ANI  @  $E AND  ANI  !  MBV2 ;
\ Set I1 and/or I0 of the INPUTs, then call AND01, OR01, XOR01, INVERT0 and see the result of the logic result in O0
: AND01    IN @  DUP 1 RSHIFT AND 01 AND  OUTP !  MBV2  ;   \ 
: OR01     IN @  DUP 1 RSHIFT OR  01 AND  OUTP !  MBV2  ;   \ 
: XOR01    IN @  DUP 1 RSHIFT XOR 01 AND  OUTP !  MBV2  ;   \ 
: INVERT0  IN @  INVERT           01 AND  OUTP !  MBV2  ;   \ 
\ Forth Words used 
\  0 INCLUDE   
\  1 HEX       
\  2 \         
\  3 :         
\  4 ."        
\  5 CR        
\  6 ;         
\  8 Variable  
\  9 DUP       
\ 10 $n        
\ 11 AND       
\ 12 IF        
\ 13 ELSE      
\ 14 THEN      
\ 15 LSHIFT    
\ 16 SPACE     
\ 17 DROP      
\ 18 DV        
\ 19 @         
\ 20 ?DO       
\ 21 LOOP      
\ 22 PAGE      
\ 23 BEGIN     
\ 24 1+        
\ 25 !         
\ 26 MS        
\ 27 KEY?      
\ 28 UNTIL     
\ 29 EMIT      
\ 30 .S        
\ 31 .         
\ 32 >R        
\ 33 R>        
\ 34 (  )      
\  - this covers all of the Forth words used. Not programmed optimally - not the target -  beginner's code for beginners
sos     page  cr cr ." Hello World - and wait a second"  cr cr  1000 ms  \ send  SOS  and Hello World 
\  type SOS <cr>, COUNTER <cr> to start COUNTER, 200 SCOUNTER <cr> or start setting BITS using the control words with H/L
\ PWH PWL  T3H T3L  T2H T2L  T1H T1L  O3H O3L  O2H O2L  O1H O1L  O0H O0L  I3H I3L  I2H I2L  I1H I1L  I0H I0L  DEBUG  ????

\ : beldel  07 emit ms ;  \ send our the Bell signal via the loudspeaker, either with short pause or with a long pause
\ 
\ : SOS 100 beldel 100 beldel 100 beldel 600 beldel 600 beldel 600 beldel 100 beldel 0100 beldel 100 beldel ;

